// Versione ottimizzata per risparmiare memoria.
// 1) Utilizzo bool anziche' un enumerato per 
//    rappresentare ogni finestra.
// 2) Alloco i vettori dei piani su richiesta, cioe' 
//    quando questi vengono aggiunti e non tutti 
//    insieme nel costruttore.

#include <iostream>
using namespace std;

class Palazzo
{
    bool** v; // false=finestra chiusa, true=finestra aperta
    int maxPiani;
    int quantiPiani;
    
  public:
    Palazzo(int N);
    Palazzo(const Palazzo& p);
    bool aggiungi();
    void stampa(); // O MEGLIO: void stampa()const;
    
    // --- SECONDA PARTE --- //
    void cambia(int i, int j);
    Palazzo& operator%=(const Palazzo& p);
    int operator!(); // O MEGLIO: int operator!()const;
    ~Palazzo();
};
